
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/derivatives_automaton.hh>
%}
%define alg_derivatives_automaton_interface(Automaton, GenAutomaton, Series, Exp, HList)
static void derivatives_automaton(Automaton& a, const Exp& e) ;
static void derivatives_automaton(GenAutomaton& a, const Exp& e) ;
%enddef
%define alg_derivatives_automaton_interface_impl(Automaton, GenAutomaton, Series, Exp, HList)
static  void derivatives_automaton(Automaton& a, const Exp& e) { return vcsn::derivatives_automaton(*a, e); }
static  void derivatives_automaton(GenAutomaton& a, const Exp& e) { return vcsn::derivatives_automaton(*a, e); }
%enddef
%define alg_interface_derivatives_automaton(Kind)
%{
struct Kind ##_alg_derivatives_automaton {
alg_derivatives_automaton_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_set_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
%enddef
%define decl_alg_derivatives_automaton(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_derivatives_automaton {
alg_derivatives_automaton_interface_impl(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_set_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
struct Kind ##_alg_derivatives_automaton {
alg_derivatives_automaton_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_set_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%enddef
